<template>
  <GenericLayout>
    <template #header>
      <Header
        fastplatform-logo
        :title="pageTitle"
      />
    </template>
    <template #page-content>
      <div
        class="q-gutter-y-md"
        style="height: 100%;"
      >
        <template v-if="isDesktopPlatform">
          <div
            class="page-title"
            v-if="pageTitle"
          >
            {{ pageTitle }}
          </div>
          <div
            class="page-subtitle"
            style="padding-bottom: 0"
            v-if="pageSubTitle"
          >
            {{ pageSubTitle }}
          </div>
        </template>

        <template v-if="loading">
          <div
            class="column flex-center"
            style="height: 100%;"
            key="photo-loader"
          >
            <q-spinner
              color=""
              size="3em"
            />
            <translate>Loading your photos ...</translate>
          </div>
        </template>

        <template v-else>
          <q-card :square="!isDesktopPlatform">
            <PhotosMap
              :photos="photos"
              :active-photo="activePhoto"
              @set-active-photo="setActivePhoto"
              :map-style="mapStyle"
            />
          </q-card>

          <q-card :square="!isDesktopPlatform">
            <q-card-section v-if="showReUploadButton">
              <q-btn
                color="primary"
                outline
                @click="reUploadLocalFiles"
              >
                <translate>Re-upload all local files</translate>
              </q-btn>
            </q-card-section>

            <template v-if="showTakePhoto && isDesktopPlatform">
              <q-card-actions
                align="right"
                class="q-pt-md"
              >
                <q-btn
                  color="primary"
                  class="q-mr-sm q-mb-sm"
                  outline
                  @click="takePhoto"
                >
                  <q-icon
                    name="las la-camera"
                    class="q-mr-sm"
                  />
                  <translate>
                    Take a photo
                  </translate>
                </q-btn>
              </q-card-actions>

              <q-separator />
            </template>

            <PhotosPreviewList
              v-if="photos.length > 0"
              :photos="photos"
              :active-photo="activePhoto"
              @photo-deleted="deleteLocalPhoto"
            />

            <template v-else>
              <q-card-section class="text-body2">
                <translate>
                  No photos for this campaign
                </translate>
              </q-card-section>
            </template>
          </q-card>

          <q-banner
            v-if="!showTakePhoto"
            class="bg-transparent text-grey"
          >
            <template #avatar>
              <q-icon
                name="la la-info-circle"
                color="grey"
              />
            </template>
            <translate>
              The camera is not available on your device.
            </translate>
          </q-banner>
        </template>

        <FabTakePhoto v-if="showTakePhoto && !isDesktopPlatform" />
      </div>
    </template>
    <template #footer>
      <Footer />
    </template>
  </GenericLayout>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import GenericLayout from 'src/layouts/GenericLayout'
import Header from 'src/components/layouts/Header'
import Footer from 'src/components/layouts/Footer'
import PhotosMap from 'src/pages/photos/photos/components/PhotosMap'
import PhotosPreviewList from 'src/pages/photos/components/PhotosPreviewList'
import FabTakePhoto from 'src/pages/photos/components/FabTakePhoto'
import { FILE_UPLOAD_STATUS, uploadServiceInstance } from 'src/services/photo/upload'
import queryGeoTaggedPhotos from 'src/pages/photos/photos/graphql/queryGeoTaggedPhotos'
import featureFlags from 'src/services/feature-flags'
import { isUserMediaAvailable } from 'src/services/photo/camera'

export default {
  name: 'PhotosPage',
  mixins: [
    PlatformMixin
  ],
  components: {
    GenericLayout,
    Header,
    Footer,
    PhotosMap,
    PhotosPreviewList,
    FabTakePhoto
  },
  data () {
    return {
      activePhoto: null,
      livePhotos: null,
      localPhotos: [],
      loadingLocalPhotos: true,
      lastFetchAt: null,
      lastLocalPhotoChecksedAt: null
    }
  },
  computed: {
    pageTitle () {
      return this.$gettext('Photos')
    },
    pageSubTitle () {
      return this.$store.state.fastplatform.holdingCampaign.campaign.name
    },
    holdingCampaignId () {
      return this.$store.state.fastplatform.holdingCampaign.id
    },
    loading () {
      if (this.lookForLocalPhotos && this.loadingLocalPhotos) {
        return true
      }
      return !this.livePhotos && this.$apollo.queries.uploadedPhotos.loading
    },
    lookForLocalPhotos () {
      return this.isMobileApp
    },
    photos () {
      const photos = [...this.localPhotos]
      if (this.livePhotos) {
        photos.push(...this.livePhotos)
      }
      return photos
    },
    lastUploadedPhotoAt () {
      return this.$store.state.appState.lastUploadedPhotoAt
    },
    lastPhotoUploadFailureAt () {
      return this.$store.state.appState.lastPhotoUploadFailureAt
    },
    displayRestartUploadJob () {
      // determine if a button to restart the upload job should be displayed
      if (this.lookForLocalPhotos) {
        if (this.localPhotos.length > 0) {
          for (let i = 0; i < this.localPhotos.length; i++) {
            if (this.localPhotos[i].status === FILE_UPLOAD_STATUS.FAILED) {
              return true
            }
          }
          return false
        } else {
          return false
        }
      } else {
        return false
      }
    },
    showReUploadButton () {
      if (this.isMobileApp && this.localPhotos.length > 0) {
        return this.localPhotos.filter(p => p.status === FILE_UPLOAD_STATUS.FAILED).length > 0
      } else {
        return false
      }
    },
    mapStyle () {
      if (this.isDesktopPlatform) {
        return 'height: 350px;width:100%;'
      } else {
        return 'height: 275px;width:100%;'
      }
    },
    canTakePhoto () {
      return featureFlags.canTakePhoto()
    },
    isCameraAvailable () {
      return this.isMobileApp || isUserMediaAvailable()
    },
    showTakePhoto () {
      return this.canTakePhoto && this.isCameraAvailable
    }
  },
  apollo: {
    uploadedPhotos: {
      query: queryGeoTaggedPhotos,
      notifyOnNetworkStatusChange: true,
      variables () {
        return {
          holdingCampaignId: this.holdingCampaignId
        }
      },
      update: data => data.photos,
      result ({ data }) {
        // Add the result to the photos list
        if (data?.photos) {
          this.livePhotos = data.photos
        }
      }
    }
  },
  methods: {
    deleteLocalPhoto (photo) {
      const localPhotoIndex = this.localPhotos.findIndex(p => p.id === photo.id)
      if (localPhotoIndex > -1) {
        this.localPhotos.splice(localPhotoIndex, 1)
      }
    },
    async getLocalPhotos () {
      if (this.lookForLocalPhotos) {
        this.loadingLocalPhotos = true
        this.lastLocalPhotosCheckedAt = Date.now()
        // return the photos that are not yet uploaded
        const res = await uploadServiceInstance.listPhotosToUploadByHoldingCampaign(this.holdingCampaignId)
        if (res.error || !res.photos) {
          console.error('Could not retrieve local photos', res.error)
          // TODO handle error
        } else {
          this.localPhotos = res.photos
        }
      }
      this.loadingLocalPhotos = false
    },
    reUploadLocalFiles () {
      uploadServiceInstance.startUpload({ retryFailedFiles: true })
    },
    setActivePhoto (photo) {
      this.activePhoto = photo
    },
    takePhoto () {
      this.$router.push({ name: 'takePhoto' })
    }
  },
  watch: {
    lastUploadedPhotoAt (uploadedAt) {
      // refresh photo if necessary when a local photo as been uploaded
      if (uploadedAt > this.lastFetchAt) {
        // wait for thumbnail generation (1sec) then refetch photos (uploaded and local)
        window.setTimeout(() => {
          this.lastFetchAt = Date.now()
          Promise.all([
            this.$apollo.queries.uploadedPhotos.refetch(),
            this.getLocalPhotos()
          ]).then(() => {
            this.$q.notify({
              message: this.$gettext('Photo successfully uploaded.'),
              color: 'positive'
            })
          })
        }, 1000)
      }
    },
    lastPhotoUploadFailureAt () {
      // wait one second to "group" potential upload failures
      window.setTimeout(() => {
        if (this.lastPhotoUploadFailureAt > this.lastLocalPhotosCheckedAt) {
          // refresh local photos when a photo local has failed
          this.getLocalPhotos()
        }
      }, 1000)
    }
  },
  mounted () {
    this.lastFetchAt = Date.now()
    // get the local photos (only for mobile app version)
    this.getLocalPhotos()
  }
}
</script>
